/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.traversalAlgorithms;

import georouting.Graph;
import georouting.Node;
import georouting.TraversalAlgorithm;
import georouting.node.CFRNode;
import java.util.ArrayList;

/**
 *
 * @author Jordan
 */
public class Tracer extends TraversalAlgorithm{
    private ArrayList<Node> path_;
    
    public Tracer(Graph g, ArrayList<Node> path){
        super(g, path.get(0), path.get(path.size() - 1));
        path_ = path;
        path_.remove(0);
    }
    
    @Override
    public boolean done(){
        return _current == _destination && path_.isEmpty();
    }
    
    @Override
    public void advance(){
        if(!path_.isEmpty()){
            if(_current.neighborhood().contains(path_.get(0))){
                ((CFRNode)path_.get(0)).setPreference((CFRNode)_current);
                moveTo(path_.get(0));
                path_.remove(0);
            }
        }
        else if(done()){
            PostOffice.instance().remove(this);
        }
    }

    private void moveTo(Node n) {
        _hops ++;
        _current = n;
        PostOffice.instance().addPacket();
    }
}
